// These functions are the server side part of the libnfspdctl/nfspdctl.h API
// The expected functions and returned values are supposed to be the same
// If not the case, it's a bug !)
//
// Changelog:
//   200208xx added get_all_iod() - adrien
// 
// Author: NFSP team
// Date: 2002/07
// Licence: GPLv2

#ifndef __NFSP_VIODS_H__
#define __NFSP_VIODS_H__ 1

#ifdef VIODS_SUPPORT

#include <netinet/in.h>		// for struct sockaddr_in

// Use this function prior to any other one !
int nfspd_init_svc();

int nfspd_addiod_svc(struct sockaddr_in *sinp);
int nfspd_freeiod_svc(int ih);
int nfspd_bindiod_svc(int iviod, int ih);
int nfspd_unbindiod_svc(int ih);

int nfspd_setnbviods_svc(int nbviods);
int nfspd_getnbviods_svc();

int nfspd_drop_svc();
int nfspd_forward_svc();
int nfspd_flush_svc();
int nfspd_get_viod_size_svc(int iviod);

// -----------------------------------------------------------------
// Ugly ugly ugly...
// FIXME: clean this when plain iod support is removed
//
#define viods_nb (nfspd_getnbviods_svc())

// Return a pointer to a physical iod within the viod group #iviod
// and give a spin to the pointer wheel
struct sockaddr_in * get_iod(int iviod);

#ifdef WRITEMIRROR_SUPPORT
// Used to fill the nextiods[] field of an iod write mirror request
// 
// If iod_tab != NULL, fills iod_tab with the iods of the viod #iviod
// Always return the number of iods in the viod group #iviod
int get_all_iod(int iviod, struct sockaddr_in* iod_tab);
#endif

typedef enum {
	NFSPD_FORWARDING_MODE,
	NFSPD_DROPPING_MODE,
} nfspd_state_t;
// nfspd_state_t get_state();
#define get_state() (nfspd_state)
extern nfspd_state_t nfspd_state;

#ifdef SHOWINFO
// For debug purposes only
void nfspd_viods_showall();
#endif

#endif /* VIODS_SUPPORT */

#endif /* !__NFSP_VIODS_H__ */

